Whamcloud - gitweb
LU-12410 tests: Add auster option to skip setup
[fs/lustre-release.git] / lustre / tests / auster
index ef6ec12..fc09ae0 100755 (executable)
@@ -14,7 +14,7 @@ export TF_FAIL=/tmp/tf.fail
 export TF_SKIP=/tmp/tf.skip
 
 usage() {
-    less -F <<EOF
+       less -F <<EOF
 Usage ${0##*/} [options]  suite [suite options] [suite [suite options]]
 Run Lustre regression tests suites.
       -c CONFIG Test environment config file
@@ -23,6 +23,7 @@ Run Lustre regression tests suites.
       -f STR    Config name (cfg/<name>.sh)
       -g GROUP  Test group file (Overrides tests listed on command line)
       -S TESTSUITE First test suite to run allows for restarts
+      -H        Honor the EXCEPT and ALWAYS_EXCEPT list when --only is used
       -i N      Repeat tests N times (default 1). A new directory
                 will be created under LOGDIR for each iteration.
       -k        Don't stop when subtests fail
@@ -32,6 +33,8 @@ Run Lustre regression tests suites.
       -v        Verbose mode
       -l        Send logs to the Maloo database after run
                   (can be done later by running maloo_upload.sh)
+      -L        Script language of test suite. Default: bash
+      -N        No setup. Do not setup Lustre prior to executing test suite.
       -h        This help.
 
 Suite options
@@ -56,7 +59,7 @@ Run all tests in the regression group 5 times using large config.
   auster -f large -g test-groups/regression -i 5
 
 EOF
-    exit
+       exit
 }
 
 dry_run=false
@@ -65,28 +68,34 @@ verbose=false
 repeat_count=1
 upload_logs=false
 reformat=false
+script_lang=bash
 test_logs_dir=/tmp/test_logs/$(date +%Y-%m-%d)/$(date +%H%M%S)
+export HONOR_EXCEPT=
+do_setup=true
 export ${SLOW:=no}
 export ${NAME:=local}
-while getopts "c:d:D:nkf:S:g:i:rRslhv" opt
+while getopts "c:d:D:nkf:S:g:Hi:rRslL:Nhv" opt
 do
-    case "$opt" in
-        c) export CONFIG=$OPTARG;;
-        d) test_logs_dir=$OPTARG/$(date +%Y-%m-%d)/$(date +%H%M%S);;
-        D) test_logs_dir=$OPTARG;;
-        g) test_group_file=$OPTARG;;
-        S) FIRST_SUITE=$OPTARG;;
-        k) export FAIL_ON_ERROR=false;;
-        n) dry_run=:;;
-        v) verbose=:;;
-        i) repeat_count=$OPTARG;;
-        f) NAME=$OPTARG;;
-        R) do_reset=:;;
-        r) reformat=:;;
-       s) export SLOW=yes;;
-        l) upload_logs=true;;
-        h|\?) usage;;
-    esac
+       case "$opt" in
+               c) export CONFIG=$OPTARG;;
+               d) test_logs_dir=$OPTARG/$(date +%Y-%m-%d)/$(date +%H%M%S);;
+               D) test_logs_dir=$OPTARG;;
+               g) test_group_file=$OPTARG;;
+               S) FIRST_SUITE=$OPTARG;;
+               k) export FAIL_ON_ERROR=false;;
+               n) dry_run=:;;
+               v) verbose=:;;
+               H) export HONOR_EXCEPT="y";;
+               i) repeat_count=$OPTARG;;
+               f) NAME=$OPTARG;;
+               R) do_reset=:;;
+               r) reformat=:;;
+               s) export SLOW=yes;;
+               l) upload_logs=true;;
+               L) script_lang=$OPTARG;;
+               N) do_setup=false;;
+               h|\?) usage;;
+       esac
 done
 
 # If a test_group_file is specified, then ignore rest of command line
@@ -97,17 +106,6 @@ else
     shift $((OPTIND -1))
 fi
 
-#
-# Various paramters for the tests scripts
-#
-#: ${SIZE:=$((RAMKB * 2))}
-#: ${RSIZE:=512}
-#: ${UID:=1000}
-#: ${MOUNT=/mnt/lustre}
-#: ${MOUNT2:=${MOUNT}2}
-#: ${COUNT:=1000}
-#: ${TMP:=/tmp}
-
 reset_lustre() {
     if $do_reset; then
         stopall
@@ -131,33 +129,34 @@ print_summary () {
 
 
 setup_if_needed() {
-    nfs_client_mode && return
-    auster_cleanup=false
-
-    local MOUNTED=$(mounted_lustre_filesystems)
-    if $(echo $MOUNTED' ' | grep -w -q $MOUNT' '); then
-        check_config_clients $MOUNT
-       # init_facets_vars
-       # init_param_vars
-        return
-    fi
+       ! ${do_setup} && return
+       nfs_client_mode && return
+       AUSTER_CLEANUP=false
+
+       local MOUNTED=$(mounted_lustre_filesystems)
+       if $(echo $MOUNTED' ' | grep -w -q $MOUNT' '); then
+               check_config_clients $MOUNT
+               # init_facets_vars
+               # init_param_vars
+               return
+       fi
 
-    echo "Lustre is not mounted, trying to do setup ... "
-    $reformat && formatall
-    setupall
+       echo "Lustre is not mounted, trying to do setup ... "
+       $reformat && CLEANUP_DM_DEV=true formatall
+       setupall
 
-    MOUNTED=$(mounted_lustre_filesystems)
-    if ! $(echo $MOUNTED' ' | grep -w -q $MOUNT' '); then
-        echo "Lustre is not mounted after setup! "
-        exit 1
-    fi
-    auster_cleanup=true
+       MOUNTED=$(mounted_lustre_filesystems)
+       if ! $(echo $MOUNTED' ' | grep -w -q $MOUNT' '); then
+               echo "Lustre is not mounted after setup! "
+               exit 1
+       fi
+       AUSTER_CLEANUP=true
 }
 
 cleanup_if_needed() {
-    if $auster_cleanup; then
-        cleanupall
-    fi
+       if $AUSTER_CLEANUP; then
+               cleanupall
+       fi
 }
 
 find_script_in_path() {
@@ -201,7 +200,7 @@ run_suite() {
        rm -f $TF_FAIL
        touch $TF_SKIP
        local start_ts=$(date +%s)
-       doit bash $suite_script
+       doit $script_lang $suite_script
        local rc=$?
        local duration=$(($(date +%s) - $start_ts))